# coding: utf-8

"""
    WALKOFF

    An active cyber defense development framework enabling orchestration capabilities to be written once and deployed across WALKOFF-enabled orchestration tools. https://nsacyber.github.io/WALKOFF/  # noqa: E501

    The version of the OpenAPI document: 0.9.1
    Contact: walkoff@nsa.gov
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class Condition(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'walkoff_type': 'str',
        'app_name': 'str',
        'app_version': 'str',
        'conditional': 'str',
        'errors': 'list[str]',
        'id_': 'str',
        'is_valid': 'bool',
        'label': 'str',
        'name': 'str',
        'position': 'Position'
    }

    attribute_map = {
        'walkoff_type': '_walkoff_type',
        'app_name': 'app_name',
        'app_version': 'app_version',
        'conditional': 'conditional',
        'errors': 'errors',
        'id_': 'id_',
        'is_valid': 'is_valid',
        'label': 'label',
        'name': 'name',
        'position': 'position'
    }

    def __init__(self, walkoff_type=None, app_name=None, app_version=None, conditional=None, errors=None, id_=None, is_valid=None, label=None, name=None, position=None):  # noqa: E501
        """Condition - a model defined in OpenAPI"""  # noqa: E501

        self._walkoff_type = None
        self._app_name = None
        self._app_version = None
        self._conditional = None
        self._errors = None
        self._id_ = None
        self._is_valid = None
        self._label = None
        self._name = None
        self._position = None
        self.discriminator = None

        if walkoff_type is not None:
            self.walkoff_type = walkoff_type
        if app_name is not None:
            self.app_name = app_name
        if app_version is not None:
            self.app_version = app_version
        self.conditional = conditional
        if errors is not None:
            self.errors = errors
        if id_ is not None:
            self.id_ = id_
        if is_valid is not None:
            self.is_valid = is_valid
        self.label = label
        if name is not None:
            self.name = name
        if position is not None:
            self.position = position

    @property
    def walkoff_type(self):
        """Gets the walkoff_type of this Condition.  # noqa: E501

        Workflow type for json decoder  # noqa: E501

        :return: The walkoff_type of this Condition.  # noqa: E501
        :rtype: str
        """
        return self._walkoff_type

    @walkoff_type.setter
    def walkoff_type(self, walkoff_type):
        """Sets the walkoff_type of this Condition.

        Workflow type for json decoder  # noqa: E501

        :param walkoff_type: The walkoff_type of this Condition.  # noqa: E501
        :type: str
        """

        self._walkoff_type = walkoff_type

    @property
    def app_name(self):
        """Gets the app_name of this Condition.  # noqa: E501


        :return: The app_name of this Condition.  # noqa: E501
        :rtype: str
        """
        return self._app_name

    @app_name.setter
    def app_name(self, app_name):
        """Sets the app_name of this Condition.


        :param app_name: The app_name of this Condition.  # noqa: E501
        :type: str
        """
        allowed_values = ["Builtin"]  # noqa: E501
        if app_name not in allowed_values:
            raise ValueError(
                "Invalid value for `app_name` ({0}), must be one of {1}"  # noqa: E501
                .format(app_name, allowed_values)
            )

        self._app_name = app_name

    @property
    def app_version(self):
        """Gets the app_version of this Condition.  # noqa: E501

        The version of the app to which the action belongs  # noqa: E501

        :return: The app_version of this Condition.  # noqa: E501
        :rtype: str
        """
        return self._app_version

    @app_version.setter
    def app_version(self, app_version):
        """Sets the app_version of this Condition.

        The version of the app to which the action belongs  # noqa: E501

        :param app_version: The app_version of this Condition.  # noqa: E501
        :type: str
        """

        self._app_version = app_version

    @property
    def conditional(self):
        """Gets the conditional of this Condition.  # noqa: E501


        :return: The conditional of this Condition.  # noqa: E501
        :rtype: str
        """
        return self._conditional

    @conditional.setter
    def conditional(self, conditional):
        """Sets the conditional of this Condition.


        :param conditional: The conditional of this Condition.  # noqa: E501
        :type: str
        """
        if conditional is None:
            raise ValueError("Invalid value for `conditional`, must not be `None`")  # noqa: E501

        self._conditional = conditional

    @property
    def errors(self):
        """Gets the errors of this Condition.  # noqa: E501

        Errors attached to this ExecutionElement  # noqa: E501

        :return: The errors of this Condition.  # noqa: E501
        :rtype: list[str]
        """
        return self._errors

    @errors.setter
    def errors(self, errors):
        """Sets the errors of this Condition.

        Errors attached to this ExecutionElement  # noqa: E501

        :param errors: The errors of this Condition.  # noqa: E501
        :type: list[str]
        """

        self._errors = errors

    @property
    def id_(self):
        """Gets the id_ of this Condition.  # noqa: E501

        A 32-bit hexadecimal string representing a globally unique identifier  # noqa: E501

        :return: The id_ of this Condition.  # noqa: E501
        :rtype: str
        """
        return self._id_

    @id_.setter
    def id_(self, id_):
        """Sets the id_ of this Condition.

        A 32-bit hexadecimal string representing a globally unique identifier  # noqa: E501

        :param id_: The id_ of this Condition.  # noqa: E501
        :type: str
        """

        self._id_ = id_

    @property
    def is_valid(self):
        """Gets the is_valid of this Condition.  # noqa: E501

        are the contents of this condition valid?  # noqa: E501

        :return: The is_valid of this Condition.  # noqa: E501
        :rtype: bool
        """
        return self._is_valid

    @is_valid.setter
    def is_valid(self, is_valid):
        """Sets the is_valid of this Condition.

        are the contents of this condition valid?  # noqa: E501

        :param is_valid: The is_valid of this Condition.  # noqa: E501
        :type: bool
        """

        self._is_valid = is_valid

    @property
    def label(self):
        """Gets the label of this Condition.  # noqa: E501

        User-specified label for the condition  # noqa: E501

        :return: The label of this Condition.  # noqa: E501
        :rtype: str
        """
        return self._label

    @label.setter
    def label(self, label):
        """Sets the label of this Condition.

        User-specified label for the condition  # noqa: E501

        :param label: The label of this Condition.  # noqa: E501
        :type: str
        """
        if label is None:
            raise ValueError("Invalid value for `label`, must not be `None`")  # noqa: E501

        self._label = label

    @property
    def name(self):
        """Gets the name of this Condition.  # noqa: E501


        :return: The name of this Condition.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Condition.


        :param name: The name of this Condition.  # noqa: E501
        :type: str
        """
        allowed_values = ["Condition"]  # noqa: E501
        if name not in allowed_values:
            raise ValueError(
                "Invalid value for `name` ({0}), must be one of {1}"  # noqa: E501
                .format(name, allowed_values)
            )

        self._name = name

    @property
    def position(self):
        """Gets the position of this Condition.  # noqa: E501


        :return: The position of this Condition.  # noqa: E501
        :rtype: Position
        """
        return self._position

    @position.setter
    def position(self, position):
        """Sets the position of this Condition.


        :param position: The position of this Condition.  # noqa: E501
        :type: Position
        """

        self._position = position

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Condition):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
