# coding: utf-8

"""
    WALKOFF

    An active cyber defense development framework enabling orchestration capabilities to be written once and deployed across WALKOFF-enabled orchestration tools. https://nsacyber.github.io/WALKOFF/  # noqa: E501

    The version of the OpenAPI document: 0.9.1
    Contact: walkoff@nsa.gov
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class DisplayUser(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'active': 'bool',
        'id': 'int',
        'roles': 'list[int]',
        'username': 'str'
    }

    attribute_map = {
        'active': 'active',
        'id': 'id',
        'roles': 'roles',
        'username': 'username'
    }

    def __init__(self, active=None, id=None, roles=None, username=None):  # noqa: E501
        """DisplayUser - a model defined in OpenAPI"""  # noqa: E501

        self._active = None
        self._id = None
        self._roles = None
        self._username = None
        self.discriminator = None

        if active is not None:
            self.active = active
        if id is not None:
            self.id = id
        if roles is not None:
            self.roles = roles
        if username is not None:
            self.username = username

    @property
    def active(self):
        """Gets the active of this DisplayUser.  # noqa: E501

        activate/deactive a user  # noqa: E501

        :return: The active of this DisplayUser.  # noqa: E501
        :rtype: bool
        """
        return self._active

    @active.setter
    def active(self, active):
        """Sets the active of this DisplayUser.

        activate/deactive a user  # noqa: E501

        :param active: The active of this DisplayUser.  # noqa: E501
        :type: bool
        """

        self._active = active

    @property
    def id(self):
        """Gets the id of this DisplayUser.  # noqa: E501

        Database id of the user  # noqa: E501

        :return: The id of this DisplayUser.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this DisplayUser.

        Database id of the user  # noqa: E501

        :param id: The id of this DisplayUser.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def roles(self):
        """Gets the roles of this DisplayUser.  # noqa: E501

        List of role object IDs that this user possesses  # noqa: E501

        :return: The roles of this DisplayUser.  # noqa: E501
        :rtype: list[int]
        """
        return self._roles

    @roles.setter
    def roles(self, roles):
        """Sets the roles of this DisplayUser.

        List of role object IDs that this user possesses  # noqa: E501

        :param roles: The roles of this DisplayUser.  # noqa: E501
        :type: list[int]
        """

        self._roles = roles

    @property
    def username(self):
        """Gets the username of this DisplayUser.  # noqa: E501

        Username or email of the user  # noqa: E501

        :return: The username of this DisplayUser.  # noqa: E501
        :rtype: str
        """
        return self._username

    @username.setter
    def username(self, username):
        """Sets the username of this DisplayUser.

        Username or email of the user  # noqa: E501

        :param username: The username of this DisplayUser.  # noqa: E501
        :type: str
        """

        self._username = username

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DisplayUser):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
