# coding: utf-8

"""
    WALKOFF

    An active cyber defense development framework enabling orchestration capabilities to be written once and deployed across WALKOFF-enabled orchestration tools. https://nsacyber.github.io/WALKOFF/  # noqa: E501

    The version of the OpenAPI document: 0.9.1
    Contact: walkoff@nsa.gov
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class NodeStatus(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'app_name': 'str',
        'completed_at': 'datetime',
        'execution_id': 'str',
        'label': 'str',
        'name': 'str',
        'node_id': 'str',
        'result': 'object',
        'started_at': 'datetime',
        'status': 'str'
    }

    attribute_map = {
        'app_name': 'app_name',
        'completed_at': 'completed_at',
        'execution_id': 'execution_id',
        'label': 'label',
        'name': 'name',
        'node_id': 'node_id',
        'result': 'result',
        'started_at': 'started_at',
        'status': 'status'
    }

    def __init__(self, app_name=None, completed_at=None, execution_id=None, label=None, name=None, node_id=None, result=None, started_at=None, status=None):  # noqa: E501
        """NodeStatus - a model defined in OpenAPI"""  # noqa: E501

        self._app_name = None
        self._completed_at = None
        self._execution_id = None
        self._label = None
        self._name = None
        self._node_id = None
        self._result = None
        self._started_at = None
        self._status = None
        self.discriminator = None

        self.app_name = app_name
        if completed_at is not None:
            self.completed_at = completed_at
        self.execution_id = execution_id
        self.label = label
        self.name = name
        self.node_id = node_id
        if result is not None:
            self.result = result
        self.started_at = started_at
        self.status = status

    @property
    def app_name(self):
        """Gets the app_name of this NodeStatus.  # noqa: E501

        The name of the app associated with the node  # noqa: E501

        :return: The app_name of this NodeStatus.  # noqa: E501
        :rtype: str
        """
        return self._app_name

    @app_name.setter
    def app_name(self, app_name):
        """Sets the app_name of this NodeStatus.

        The name of the app associated with the node  # noqa: E501

        :param app_name: The app_name of this NodeStatus.  # noqa: E501
        :type: str
        """
        if app_name is None:
            raise ValueError("Invalid value for `app_name`, must not be `None`")  # noqa: E501

        self._app_name = app_name

    @property
    def completed_at(self):
        """Gets the completed_at of this NodeStatus.  # noqa: E501

        The timestamp of when the node completed  # noqa: E501

        :return: The completed_at of this NodeStatus.  # noqa: E501
        :rtype: datetime
        """
        return self._completed_at

    @completed_at.setter
    def completed_at(self, completed_at):
        """Sets the completed_at of this NodeStatus.

        The timestamp of when the node completed  # noqa: E501

        :param completed_at: The completed_at of this NodeStatus.  # noqa: E501
        :type: datetime
        """

        self._completed_at = completed_at

    @property
    def execution_id(self):
        """Gets the execution_id of this NodeStatus.  # noqa: E501

        A 32-bit hexadecimal string representing a globally unique identifier  # noqa: E501

        :return: The execution_id of this NodeStatus.  # noqa: E501
        :rtype: str
        """
        return self._execution_id

    @execution_id.setter
    def execution_id(self, execution_id):
        """Sets the execution_id of this NodeStatus.

        A 32-bit hexadecimal string representing a globally unique identifier  # noqa: E501

        :param execution_id: The execution_id of this NodeStatus.  # noqa: E501
        :type: str
        """
        if execution_id is None:
            raise ValueError("Invalid value for `execution_id`, must not be `None`")  # noqa: E501

        self._execution_id = execution_id

    @property
    def label(self):
        """Gets the label of this NodeStatus.  # noqa: E501

        The name of the node  # noqa: E501

        :return: The label of this NodeStatus.  # noqa: E501
        :rtype: str
        """
        return self._label

    @label.setter
    def label(self, label):
        """Sets the label of this NodeStatus.

        The name of the node  # noqa: E501

        :param label: The label of this NodeStatus.  # noqa: E501
        :type: str
        """
        if label is None:
            raise ValueError("Invalid value for `label`, must not be `None`")  # noqa: E501

        self._label = label

    @property
    def name(self):
        """Gets the name of this NodeStatus.  # noqa: E501

        The name of the node take by the node  # noqa: E501

        :return: The name of this NodeStatus.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this NodeStatus.

        The name of the node take by the node  # noqa: E501

        :param name: The name of this NodeStatus.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def node_id(self):
        """Gets the node_id of this NodeStatus.  # noqa: E501

        A 32-bit hexadecimal string representing a globally unique identifier  # noqa: E501

        :return: The node_id of this NodeStatus.  # noqa: E501
        :rtype: str
        """
        return self._node_id

    @node_id.setter
    def node_id(self, node_id):
        """Sets the node_id of this NodeStatus.

        A 32-bit hexadecimal string representing a globally unique identifier  # noqa: E501

        :param node_id: The node_id of this NodeStatus.  # noqa: E501
        :type: str
        """
        if node_id is None:
            raise ValueError("Invalid value for `node_id`, must not be `None`")  # noqa: E501

        self._node_id = node_id

    @property
    def result(self):
        """Gets the result of this NodeStatus.  # noqa: E501

        The result of the node  # noqa: E501

        :return: The result of this NodeStatus.  # noqa: E501
        :rtype: object
        """
        return self._result

    @result.setter
    def result(self, result):
        """Sets the result of this NodeStatus.

        The result of the node  # noqa: E501

        :param result: The result of this NodeStatus.  # noqa: E501
        :type: object
        """

        self._result = result

    @property
    def started_at(self):
        """Gets the started_at of this NodeStatus.  # noqa: E501

        The timestamp of when the node started  # noqa: E501

        :return: The started_at of this NodeStatus.  # noqa: E501
        :rtype: datetime
        """
        return self._started_at

    @started_at.setter
    def started_at(self, started_at):
        """Sets the started_at of this NodeStatus.

        The timestamp of when the node started  # noqa: E501

        :param started_at: The started_at of this NodeStatus.  # noqa: E501
        :type: datetime
        """
        if started_at is None:
            raise ValueError("Invalid value for `started_at`, must not be `None`")  # noqa: E501

        self._started_at = started_at

    @property
    def status(self):
        """Gets the status of this NodeStatus.  # noqa: E501

        The status of the node  # noqa: E501

        :return: The status of this NodeStatus.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this NodeStatus.

        The status of the node  # noqa: E501

        :param status: The status of this NodeStatus.  # noqa: E501
        :type: str
        """
        if status is None:
            raise ValueError("Invalid value for `status`, must not be `None`")  # noqa: E501
        allowed_values = ["EXECUTING", "SUCCESS", "FAILURE"]  # noqa: E501
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"  # noqa: E501
                .format(status, allowed_values)
            )

        self._status = status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NodeStatus):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
