# coding: utf-8

"""
    WALKOFF

    An active cyber defense development framework enabling orchestration capabilities to be written once and deployed across WALKOFF-enabled orchestration tools. https://nsacyber.github.io/WALKOFF/  # noqa: E501

    The version of the OpenAPI document: 0.9.1
    Contact: walkoff@nsa.gov
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class Resource(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'int',
        'name': 'str',
        'needed_ids': 'list[str]',
        'permissions': 'list[str]'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'needed_ids': 'needed_ids',
        'permissions': 'permissions'
    }

    def __init__(self, id=None, name=None, needed_ids=None, permissions=None):  # noqa: E501
        """Resource - a model defined in OpenAPI"""  # noqa: E501

        self._id = None
        self._name = None
        self._needed_ids = None
        self._permissions = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if needed_ids is not None:
            self.needed_ids = needed_ids
        if permissions is not None:
            self.permissions = permissions

    @property
    def id(self):
        """Gets the id of this Resource.  # noqa: E501

        ID of the object  # noqa: E501

        :return: The id of this Resource.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Resource.

        ID of the object  # noqa: E501

        :param id: The id of this Resource.  # noqa: E501
        :type: int
        """
        if id is not None and id < 1:  # noqa: E501
            raise ValueError("Invalid value for `id`, must be a value greater than or equal to `1`")  # noqa: E501

        self._id = id

    @property
    def name(self):
        """Gets the name of this Resource.  # noqa: E501

        Name of the resource  # noqa: E501

        :return: The name of this Resource.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Resource.

        Name of the resource  # noqa: E501

        :param name: The name of this Resource.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def needed_ids(self):
        """Gets the needed_ids of this Resource.  # noqa: E501

        Temp string  # noqa: E501

        :return: The needed_ids of this Resource.  # noqa: E501
        :rtype: list[str]
        """
        return self._needed_ids

    @needed_ids.setter
    def needed_ids(self, needed_ids):
        """Sets the needed_ids of this Resource.

        Temp string  # noqa: E501

        :param needed_ids: The needed_ids of this Resource.  # noqa: E501
        :type: list[str]
        """

        self._needed_ids = needed_ids

    @property
    def permissions(self):
        """Gets the permissions of this Resource.  # noqa: E501

        A list of permissions associated with this resource  # noqa: E501

        :return: The permissions of this Resource.  # noqa: E501
        :rtype: list[str]
        """
        return self._permissions

    @permissions.setter
    def permissions(self, permissions):
        """Sets the permissions of this Resource.

        A list of permissions associated with this resource  # noqa: E501

        :param permissions: The permissions of this Resource.  # noqa: E501
        :type: list[str]
        """

        self._permissions = permissions

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Resource):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
