# coding: utf-8

"""
    WALKOFF

    An active cyber defense development framework enabling orchestration capabilities to be written once and deployed across WALKOFF-enabled orchestration tools. https://nsacyber.github.io/WALKOFF/  # noqa: E501

    The version of the OpenAPI document: 0.9.1
    Contact: walkoff@nsa.gov
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class WorkflowVariable(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'walkoff_type': 'str',
        'description': 'str',
        'id_': 'str',
        'name': 'str',
        'value': 'object'
    }

    attribute_map = {
        'walkoff_type': '_walkoff_type',
        'description': 'description',
        'id_': 'id_',
        'name': 'name',
        'value': 'value'
    }

    def __init__(self, walkoff_type=None, description=None, id_=None, name=None, value=None):  # noqa: E501
        """WorkflowVariable - a model defined in OpenAPI"""  # noqa: E501

        self._walkoff_type = None
        self._description = None
        self._id_ = None
        self._name = None
        self._value = None
        self.discriminator = None

        if walkoff_type is not None:
            self.walkoff_type = walkoff_type
        if description is not None:
            self.description = description
        if id_ is not None:
            self.id_ = id_
        self.name = name
        self.value = value

    @property
    def walkoff_type(self):
        """Gets the walkoff_type of this WorkflowVariable.  # noqa: E501

        Workflow type for json decoder  # noqa: E501

        :return: The walkoff_type of this WorkflowVariable.  # noqa: E501
        :rtype: str
        """
        return self._walkoff_type

    @walkoff_type.setter
    def walkoff_type(self, walkoff_type):
        """Sets the walkoff_type of this WorkflowVariable.

        Workflow type for json decoder  # noqa: E501

        :param walkoff_type: The walkoff_type of this WorkflowVariable.  # noqa: E501
        :type: str
        """

        self._walkoff_type = walkoff_type

    @property
    def description(self):
        """Gets the description of this WorkflowVariable.  # noqa: E501

        Description of the workflow variable  # noqa: E501

        :return: The description of this WorkflowVariable.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this WorkflowVariable.

        Description of the workflow variable  # noqa: E501

        :param description: The description of this WorkflowVariable.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def id_(self):
        """Gets the id_ of this WorkflowVariable.  # noqa: E501

        A 32-bit hexadecimal string representing a globally unique identifier  # noqa: E501

        :return: The id_ of this WorkflowVariable.  # noqa: E501
        :rtype: str
        """
        return self._id_

    @id_.setter
    def id_(self, id_):
        """Sets the id_ of this WorkflowVariable.

        A 32-bit hexadecimal string representing a globally unique identifier  # noqa: E501

        :param id_: The id_ of this WorkflowVariable.  # noqa: E501
        :type: str
        """

        self._id_ = id_

    @property
    def name(self):
        """Gets the name of this WorkflowVariable.  # noqa: E501

        The name of the workflow variable  # noqa: E501

        :return: The name of this WorkflowVariable.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this WorkflowVariable.

        The name of the workflow variable  # noqa: E501

        :param name: The name of this WorkflowVariable.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def value(self):
        """Gets the value of this WorkflowVariable.  # noqa: E501

        The value of the workflow variable  # noqa: E501

        :return: The value of this WorkflowVariable.  # noqa: E501
        :rtype: object
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this WorkflowVariable.

        The value of the workflow variable  # noqa: E501

        :param value: The value of this WorkflowVariable.  # noqa: E501
        :type: object
        """
        if value is None:
            raise ValueError("Invalid value for `value`, must not be `None`")  # noqa: E501

        self._value = value

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, WorkflowVariable):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
